> ## Documentation Index
> Fetch the complete documentation index at: https://devdocs.xbox.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Get Limits

> Retrieves the range of allowed values for performance and data storage retention values as well as the submeter details for each performance level.



## OpenAPI

````yaml /services/playfab/api-references/rest/insights/insights.openapi.json post /Insights/GetLimits
openapi: 3.0.0
info:
  version: '260922'
  title: PlayFab Insights API
  description: Manage the Insights performance level and data storage retention settings.
  termsOfService: https://playfab.com/terms/
  contact:
    url: https://community.playfab.com/index.html
  license:
    name: Apache 2.0
    url: https://github.com/PlayFab/API_Specs/blob/master/LICENSE
servers:
  - url: https://{titleId}.playfabapi.com
    description: PlayFab title endpoint
    variables:
      titleId:
        default: your_title_id
        description: Your PlayFab title ID (hex).
security: []
tags:
  - name: Analytics
    description: Analytics APIs
paths:
  /Insights/GetLimits:
    post:
      tags:
        - Analytics
      summary: Get Limits
      description: >-
        Retrieves the range of allowed values for performance and data storage
        retention values as well as the submeter details for each performance
        level.
      operationId: GetLimits
      requestBody:
        $ref: '#/components/requestBodies/InsightsEmptyRequest'
      responses:
        '200':
          $ref: '#/components/responses/InsightsGetLimitsResponse'
        '400':
          $ref: '#/components/responses/ApiErrorWrapper'
      security:
        - EntityToken: []
components:
  requestBodies:
    InsightsEmptyRequest:
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/InsightsEmptyRequest'
  responses:
    InsightsGetLimitsResponse:
      description: ''
      content:
        application/json:
          schema:
            type: object
            properties:
              code:
                type: integer
                description: >-
                  The Http status code. If X-ReportErrorAsSuccess header is set
                  to true, this will report the actual http error code.
              status:
                type: string
                description: The Http status code as a string.
              data:
                $ref: '#/components/schemas/InsightsGetLimitsResponse'
    ApiErrorWrapper:
      description: This is the outer wrapper for all responses with errors
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ApiErrorWrapper'
  schemas:
    InsightsEmptyRequest:
      type: object
      properties:
        CustomTags:
          description: >-
            The optional custom tags associated with the request (e.g. build
            number, external trace identifiers, etc.).
          type: object
      example: {}
    InsightsGetLimitsResponse:
      type: object
      properties:
        DefaultPerformanceLevel:
          description: Default Insights performance level.
          type: number
          x-actualtype: int32
        DefaultStorageRetentionDays:
          description: Default Insights data storage retention days.
          type: number
          x-actualtype: int32
        StorageMaxRetentionDays:
          description: Maximum allowed data storage retention days.
          type: number
          x-actualtype: int32
        StorageMinRetentionDays:
          description: Minimum allowed data storage retention days.
          type: number
          x-actualtype: int32
        SubMeters:
          description: List of Insights submeter limits for the allowed performance levels.
          type: array
          items:
            $ref: '#/components/schemas/InsightsPerformanceLevel'
          x-isclass: true
      required:
        - StorageMinRetentionDays
        - StorageMaxRetentionDays
        - DefaultPerformanceLevel
        - DefaultStorageRetentionDays
    ApiErrorWrapper:
      description: The basic wrapper around every failed API response
      type: object
      properties:
        code:
          description: Numerical HTTP code
          type: integer
        status:
          description: String HTTP code
          type: string
        error:
          description: Playfab error code
          type: string
        errorCode:
          description: Numerical PlayFab error code
          type: integer
        errorMessage:
          description: Description for the PlayFab errorCode
          type: string
        errorDetails:
          description: Detailed description of individual issues with the request object
          type: object
      required:
        - code
        - errorCode
    InsightsPerformanceLevel:
      type: object
      properties:
        ActiveEventExports:
          description: Number of allowed active event exports. This value is always zero.
          type: number
          x-actualtype: int32
        CacheSizeMB:
          description: Maximum cache size.
          type: number
          x-actualtype: int32
        Concurrency:
          description: Maximum number of concurrent queries.
          type: number
          x-actualtype: int32
        CreditsPerMinute:
          description: Number of Insights credits consumed per minute.
          type: number
          x-actualtype: double
        EventsPerSecond:
          description: Maximum events per second.
          type: number
          x-actualtype: int32
        Level:
          description: Performance level.
          type: number
          x-actualtype: int32
        MaxMemoryPerQueryMB:
          description: Maximum amount of memory allowed per query.
          type: number
          x-actualtype: int32
        VirtualCpuCores:
          description: Amount of compute power allocated for queries and operations.
          type: number
          x-actualtype: int32
      required:
        - Level
        - EventsPerSecond
        - Concurrency
        - MaxMemoryPerQueryMB
        - CacheSizeMB
        - VirtualCpuCores
        - CreditsPerMinute
        - ActiveEventExports
  securitySchemes:
    EntityToken:
      type: apiKey
      in: header
      name: X-EntityToken
      description: >-
        This API requires an Entity Session Token, available from the Entity
        GetEntityToken method.

````

## Related topics

- [Get Limits](/services/playfab/api-references/rest/insights/analytics/get-limits.md)
- [Fine-Grained Rate Limiting](/services/xbox-services/develop/best-practices/live-fine-grained-rate-limiting.md)
- [Insights Best Practices](/services/playfab/data-analytics/legacy/insights/best-practices.md)
- [Limits on Leaderboards](/services/playfab/community/leaderboards/limits-leaderboards.md)
- [Limits on statistics](/services/playfab/player-progression/statistics/limits-statistics.md)
